'use strict';

var _require = require('q-mod-myfs'),
    ifExists = _require.ifExists,
    delDir = _require.delDir;

var path = require('path');
///////////////////////////////////////// HELPERS /////////////////

function deletePreviousLogFile(fileName) {
  var p = path.resolve(process.cwd(), fileName);
  ifExists(p, 'boolean') && delDir(p);
  // console.log('deleted log file....');
}

function getArrOfMethods(obj) {
  var arr = [];
  Object.keys(obj).forEach(function (key) {
    return arr.push(key);
  });
  return arr;
}

function padNr(nr) {
  var newNr = ('0000000' + nr).substr(-3);
  return newNr + ' '; // + spacja
}

function padRightLvls(lvl, char) {
  var maxl = 7;
  var padded = new String('| ').concat(lvl.toUpperCase()).concat(char.repeat(maxl)).slice(0, maxl + 2) // 2 for initial sting "| " compensation
  .concat('\u2002');
  return padded;
}

function addLevelMethodsBasedOnWinstonInstance(lvls, target) {
  // code embrittlement due to default winston log levels
  // watchout when implementing custom log levels
  lvls.forEach(function (lvl) {
    function lvlMethBoilerP(lvl) {
      var msg = 'msg';
      var meta = 'meta';
      if (lvl === 'error' || lvl === 'warn' || lvl === 'info') {
        var bodyFn = 'let fullMsg = msg;' + ('return this.winstonLogger.' + lvl + '(fullMsg, meta);');
        return new Function(msg, meta, bodyFn);
      } else {
        var _bodyFn = 'this.ctxStep += 1;' + 'let fullMsg = this.padNr(this.ctxStep) + this.ctxVar + this.fnNameVar + msg;' + ('return this.winstonLogger.' + lvl + '(fullMsg, meta)');
        return new Function(msg, meta, _bodyFn);
      }
    }
    var genFn = lvlMethBoilerP(lvl);
    target[lvl] = genFn;
  });
}

// module API::
module.exports = {
  getArrOfMethods: getArrOfMethods,
  addLevelMethodsBasedOnWinstonInstance: addLevelMethodsBasedOnWinstonInstance,
  padNr: padNr,
  deletePreviousLogFile: deletePreviousLogFile,
  padRightLvls: padRightLvls
};